#include "gloobus-preview-interface-music.h"

// =========================== ~iMUSIC ======================================== //
iMusic::~iMusic()
{
	g_source_remove(m_timeout_id);
}

// ================================== DRAW  =================================== //
void iMusic::draw (GtkContainer * container)
{
	draw_image		( GTK_CONTAINER(container ));
	draw_file_info	( GTK_CONTAINER(container ));
	draw_controls	( GTK_CONTAINER(container ));
	play();
	m_timeout_id = g_timeout_add (100, &iMusic::trick2, this);				//Get new position
}



// ================================== DRAW FILE INFO =================================== //
void iMusic::draw_file_info(GtkContainer * container)
{
	string text = get_song_name() + "\n" + get_song_artist() + " - " + get_song_album();
	draw_properties ( container, text,25, get_height()+ SHADOW_WIDTH + HEADER_HEIGHT);

}
// ================================== DRAW CONTROLS =================================== //
void iMusic::draw_controls(GtkContainer * container)
{

		//m_adjustment = gtk_adjustment_new (0, 0, 101, 1, 5, 25);
       	//m_scale = gtk_hscale_new (GTK_ADJUSTMENT (m_adjustment));
		m_scale = gtk_hscale_new_with_range(0,100,1);
		gtk_scale_set_draw_value(GTK_SCALE(m_scale), false);			//Do not draw the numbers
		GtkWidget * hbox = gtk_hbox_new   (false,3);
       	gtk_box_pack_end (GTK_BOX (hbox), m_scale, TRUE, TRUE, 2);
		
	
		gtk_fixed_put			( GTK_FIXED(container),hbox, 15 , get_height() -5 );
	    gtk_widget_set_usize	( hbox, get_width()-10,  35);		
		gtk_widget_show_all		( hbox );

		//When the seek bar is moved, change the position
		g_signal_connect (G_OBJECT (m_scale), "change-value", G_CALLBACK (&iMusic::trick), this);
}

// ================================== DRAW POSITION =================================== //
// Request the postion to the plugin and puts the range to this new position
void iMusic::draw_position( void )
{
	gtk_range_set_value (GTK_RANGE (m_scale), get_position());
}
