#include "plugin-openoffice.h"

#define WIDTH_PERCENT 0.8
//======================= CONSTRUCTOR ===================== //
iOO::iOO(void)
{
	m_document = NULL;
}

void iOO::end_plugin(void)
{

}
//====================== LOAD ==============================//
void iOO::load_pdf()
{

	convert_to_pdf();
	string final_name = m_filename.substr(0, m_filename.rfind("."));
	final_name = final_name + ".pdf";
	
	GFile * gfile    = g_file_new_for_path (final_name.c_str () );
	
	//g_debug("New file: %s", final_name.c_str());
	//m_document = poppler_document_new_from_file (g_file_get_uri (gfile), NULL, NULL);
	m_document = poppler_document_new_from_file ("file:///tmp/gloobus_temp.pdf", NULL, NULL);
  	if (m_document == NULL)
	{
    	g_critical("PLUGIN: Error loading PDF\n");
    	exit(-1);
    }

    m_page = poppler_document_get_page (m_document, 0);
    if (m_page == NULL)
	{
		g_critical("PLUGIN: Page not found\n");
		exit(-1);
	}     

	get_scale();
	
	//Delete the temp file
	string cmd = "rm /tmp/gloobus_temp.pdf";
	g_spawn_command_line_sync(cmd.c_str(), NULL, NULL, NULL, NULL);
}
//====================== CONVERT TO PDF =======================//
void iOO::convert_to_pdf	( void )
{

	string cmd = "unoconv --stdout \"" + m_filename + "\" > /tmp/gloobus_temp.pdf";
	//string cmd = "unoconv -f pdf " + m_filename;
	//g_debug("PLUGIN: Converting to PDF [%s]\n",cmd.c_str());
	//g_spawn_command_line_sync(cmd.c_str(), NULL, NULL, NULL, NULL);
	system(cmd.c_str());

}
//====================== GET N PAGES =======================//
int iOO::get_n_pages()
{
	if(m_document == NULL )load_pdf();
	return  poppler_document_get_n_pages(m_document);
}

//====================== GET PAGES WIDTH =======================//
int iOO::get_page_width_unscaled  ( void )
{
    if(m_document == NULL ) load_pdf();
	double x,y;
	poppler_page_get_size (m_page, &x, &y);
	return x;	

}
//====================== GET PAGES HEIGHT =======================//
int	iOO::get_page_height_unscaled ( void )
{
    if(m_document == NULL ) load_pdf();
	double x,y;
	poppler_page_get_size (m_page, &x, &y);
	return y;	
}
//====================== GET PAGES PIXBUF =======================//
#if POPPLER_CHECK_VERSION(0, 17, 0)
static void
copy_cairo_surface_to_pixbuf (cairo_surface_t *surface,
			      GdkPixbuf       *pixbuf)
{
  int cairo_width, cairo_height, cairo_rowstride;
  unsigned char *pixbuf_data, *dst, *cairo_data;
  int pixbuf_rowstride, pixbuf_n_channels;
  unsigned int *src;
  int x, y;

  cairo_width = cairo_image_surface_get_width (surface);
  cairo_height = cairo_image_surface_get_height (surface);
  cairo_rowstride = cairo_image_surface_get_stride (surface);
  cairo_data = cairo_image_surface_get_data (surface);

  pixbuf_data = gdk_pixbuf_get_pixels (pixbuf);
  pixbuf_rowstride = gdk_pixbuf_get_rowstride (pixbuf);
  pixbuf_n_channels = gdk_pixbuf_get_n_channels (pixbuf);

  if (cairo_width > gdk_pixbuf_get_width (pixbuf))
    cairo_width = gdk_pixbuf_get_width (pixbuf);
  if (cairo_height > gdk_pixbuf_get_height (pixbuf))
    cairo_height = gdk_pixbuf_get_height (pixbuf);
  for (y = 0; y < cairo_height; y++)
    {
      src = (unsigned int *) (cairo_data + y * cairo_rowstride);
      dst = pixbuf_data + y * pixbuf_rowstride;
      for (x = 0; x < cairo_width; x++) 
	{
	  dst[0] = (*src >> 16) & 0xff;
	  dst[1] = (*src >> 8) & 0xff; 
	  dst[2] = (*src >> 0) & 0xff;
	  if (pixbuf_n_channels == 4)
	      dst[3] = (*src >> 24) & 0xff;
	  dst += pixbuf_n_channels;
	  src++;
	}
    }
}

static void
_poppler_page_render_to_pixbuf (PopplerPage *page,
				int src_x, int src_y,
				int src_width, int src_height,
				double scale,
				int rotation,
				GdkPixbuf *pixbuf)
{
  cairo_t *cr;
  cairo_surface_t *surface;

  surface = cairo_image_surface_create (CAIRO_FORMAT_ARGB32,
					src_width, src_height);
  cr = cairo_create (surface);
  cairo_save (cr);
  switch (rotation) {
  case 90:
	  cairo_translate (cr, src_x + src_width, -src_y);
	  break;
  case 180:
	  cairo_translate (cr, src_x + src_width, src_y + src_height);
	  break;
  case 270:
	  cairo_translate (cr, -src_x, src_y + src_height);
	  break;
  default:
	  cairo_translate (cr, -src_x, -src_y);
  }

  if (scale != 1.0)
	  cairo_scale (cr, scale, scale);

  if (rotation != 0)
	  cairo_rotate (cr, rotation * G_PI / 180.0);

  poppler_page_render (page, cr);
  cairo_restore (cr);

  cairo_set_operator (cr, CAIRO_OPERATOR_DEST_OVER);
  cairo_set_source_rgb (cr, 1., 1., 1.);
  cairo_paint (cr);

  cairo_destroy (cr);

  copy_cairo_surface_to_pixbuf (surface, pixbuf);
  cairo_surface_destroy (surface);
}

void
poppler_page_render_to_pixbuf (PopplerPage *page,
			       int src_x, int src_y,
			       int src_width, int src_height,
			       double scale,
			       int rotation,
			       GdkPixbuf *pixbuf)
{
  g_return_if_fail (POPPLER_IS_PAGE (page));
  g_return_if_fail (scale > 0.0);
  g_return_if_fail (pixbuf != NULL);

  _poppler_page_render_to_pixbuf (page, src_x, src_y,
				  src_width, src_height,
				  scale, rotation,
				  pixbuf);
}
#endif

GdkPixbuf* iOO::get_page_pixbuf ( int n_page )
{
	GdkPixbuf* temp;
	
	//if(m_document == NULL ) load_pdf();
	//printf("PLUGIN: Loading Page %i\n",n_page);
	m_page 	= poppler_document_get_page 	( m_document, n_page);
	temp 	= gdk_pixbuf_new 	  			( GDK_COLORSPACE_RGB, FALSE, 8, 
											(int)(get_page_width_unscaled() * m_scale), 
											(int)(get_page_height_unscaled() * m_scale));
			  poppler_page_render_to_pixbuf ( m_page,0, 0, 
			  								(int)(get_page_width_unscaled() * m_scale),
			  								(int)(get_page_height_unscaled() * m_scale),
			  								 m_scale,0, temp); 

	return temp;
}

// ====================== GET SCALE ============================== //
void iOO::get_scale ( void )
{
	int x = get_screen_width()-150;
	int y = get_screen_height()-150;

	int x2 = get_page_width_unscaled();
	int y2 = get_page_height_unscaled();

	//g_print("MIDES:%dx%d - %dx%d\n", x,y,x2,y2);

	m_scale = x*WIDTH_PERCENT / x2;

}
// ====================== GET HEIGHT ============================== //
int iOO::get_page_height( void )
{
	//g_print("PAGE HEIGHT SCALED: %d\n",(int)(get_page_height_unscaled() * m_scale));
	//return (int)(get_page_height_unscaled() * m_scale);
	return get_screen_height()-160;
}
// ====================== GET HEIGHT ============================== //
int iOO::get_page_width( void )
{
	//g_print("PAGE WIDTH SCALED: %d\n",(int)(get_page_height_unscaled() * m_scale));
	return (int)(get_page_width_unscaled() * m_scale);
}
