#ifndef _ITTF_
#define _ITTF_

#define MANAGER_VERSION 1			// TODO: Define here the pluginManager version !!! (In pluginManager.h)
#define PLUGIN_NAME	 	"iTtf"		// TODO: Define here the plugin Name


#include "../gloobus-preview-interface-free.h"

#include <gdk/gdk.h>
#include <cairo.h> 
#include <cairo-ft.h>
#include <ft2build.h> 
#include FT_FREETYPE_H





class iTtf: public iFree
{
	private:
			cairo_font_face_t* 		m_cairo_font;
			void				load_font		(void);
	
	public:
								iTtf			(void);
								~iTtf			(void);

	virtual void			draw_free 	(GtkContainer * container);
	virtual int 			get_width	( void );
	virtual int 			get_height	( void );

};



// ============================ Class factories======================================== //
// This is "allways the same" code, just change the plugin name in the printf and the 
// return object
extern "C" iFree* create() {		
	printf("Creating iTtf...\n");
    return new iTtf;
}

extern "C" void destroy(iFree* p) {
	printf("Destroying iTtf...\n");
    delete p;
}

extern "C" int getVersion(){			//To save crashes from older versions
	return MANAGER_VERSION;
}

// ============================== REGISTER ============================================ //
// Here is where we register the new plugin, what we do is to add a map with the plugin
// name and the mime file types it can load, then, the pluginManager will take care of wich
// plugin load, depending on its file type. Just add more than one file type adding this
// two lines as many times you want.
//
//	itself.filetype = "image/bmp";			// Add another extension supported
//	pluginVector.push_back(itself);			// Add filetype that plugin reads

extern "C" 
{
   class proxy {
		public:
	   	proxy()
		{
			//TODO: Add here the mime filetypes that plugin supports
			//plugin_filetype itself = {PLUGIN_NAME,EXTENSION,TYPE,PRIORITY}
			
			plugin_filetype itself = { PLUGIN_NAME, "application/x-font-ttf","free",1};		// Initial filetype

			factory_free[itself.name] = create;		    // Register the plugin
			factoryDestroy_free[itself.name] = destroy;	// Function for destroy this plugin class
			pluginVector.push_back(itself);					// Add filetype that plugin reads
		    
		    //itself.filetype = "video/x-msvideo";			// Add another extension supported
			//pluginVector.push_back(itself);					// Add filetype that plugin reads
			
	   }
 };
 proxy p;	// When we open the dll with RTLD_NOW it creates p, and in consequence, it registers the plugin 
}

#endif

